#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include <string.h>
#include <error.h>
#include <dirent.h>

#include <gnome.h>
#include "utils.h"

extern int errno;

int cerca_itaSMS(const struct dirent *a)
{	
	gchar *b = NULL;
	b = strstr(a->d_name, ".itaSMS");
	if((b)&&(!(b[7]))) return 1;
	return 0;
}

GList *findscript(void)
{
	gint n;
	gchar *dir2;
	gchar *dir;
	struct dirent **namelist;
	GList *retr = NULL;
		
	dir2 = g_strconcat(getenv("HOME"), "/.itaSMS/", NULL);
		
	n = scandir(dir2 , &namelist, cerca_itaSMS, alphasort);
	if(n < 0 )
	{
		g_error("Error reading Home dir");
		return NULL;
	}
	
	while(n--) 
	{
		dir = g_strndup(namelist[n]->d_name, strlen(namelist[n]->d_name) - 7);	
		retr = g_list_append(retr, dir);
		/*NON DEALLOCARE DIR!!*/
	}
	
	g_free(dir2);
	g_free(namelist);	
	return retr;
}

void findnick(GList **lista_nick, GList **lista_num)
{
	gchar *file_name;
	FILE *file;
	gchar *nome;
	gchar *num;
	gchar *prefix;
	gchar *number;
	
	file_name = g_strconcat(getenv("HOME"), "/.itaSMS/nick.rubrica.sms", NULL);
	file = fopen(file_name, "r");
	if(!file) return ;
	
	(*lista_nick) = g_list_append((*lista_nick), "<insert number>");
	(*lista_num)  = g_list_append((*lista_num), "");
	
	
	while(!feof(file))
	{
		nome = (gchar *)g_malloc(50);
		prefix = (gchar *)g_malloc(5);
		num = (gchar *)g_malloc(10);
			
		fscanf(file, "%s", nome);
		if(strlen(nome))
		{
			(*lista_nick) = g_list_append((*lista_nick), nome);
		
			fscanf(file, "%s", prefix);
			fscanf(file, "%s", num);
			number = g_strconcat(prefix, num, NULL);
			(*lista_num) = g_list_append((*lista_num), number);
		}
		g_free(prefix);
		g_free(num);
	}
	
	g_free(file_name);
	return ;
}

gchar *exec_and_catch(gchar **argv)
{
  gint file_pipes[2];
  gint pid;
  gint nread;
  gchar *buf;
  
  buf = (gchar *)g_malloc(500); 

  if (pipe (file_pipes) != 0)
  {
    g_error("error in pipe!");
    return NULL;
  }

  if ((pid = fork ()) == -1)
  {
    g_error("error in forking process!");
    return NULL;
  }

  if (pid == 0)
  {
	close (0);
	close (1);
	close (2);
	dup (file_pipes[0]);
	dup (file_pipes[1]);
	dup (file_pipes[1]);
	close (file_pipes[0]);
	close (file_pipes[1]);

	if(execvp (argv[0], argv)==-1) printf("%s", strerror(errno));
	exit (127);
  }
  else
  {
    close (file_pipes[1]);
    nread = read (file_pipes[0], buf, 500);
    buf[nread] = '\0';     
    
    close (file_pipes[0]);
  }
  
  
  return buf;
}


void control_text(char *testo)
{
	unsigned int a;
	for (a = 0; a < strlen(testo); a++)
	{
		switch (testo[a])
		{
			case '\n': testo[a] = ' '; break;
			case 0x9 : testo[a] = ' '; break;
		}
	}
}

gint find_string(gconstpointer uno, gconstpointer due)
{
	if(strcmp((gchar *)uno, (gchar *)due))return 1;else return 0;
}